#!/bin/env php
<?php
require_once("/var/www/html/fop2/lib/func.php");
require_once("/var/www/html/fop2/lib/dblib.php");

$db = db_connect();
main($db);

function parse_amportal_conf($filename) {
    $file = file($filename);
    if (is_array($file)) {
        foreach ($file as $line) {
            if (preg_match("/^\s*([^=]*)\s*=\s*[\"']?([\w\/\:\.\,\}\{\>\<\(\)\*\?\%!=\+\#@&\\$-]*)[\"']?\s*([;].*)?/",$line,$matches)) {
                if(preg_match('/\$amp_conf/',$matches[1])) {
                    $matches[1] = substr($matches[1],11);
                    $matches[1] = trim($matches[1]);
                    $matches[1] = substr($matches[1],0,-2);
                }
                $matches[1] = trim($matches[1]);
                $conf[ $matches[1] ] = trim($matches[2]);
            }
        }
    } else {
        die("<h1>".sprintf("Missing or unreadable config file (%s)...cannot continue", $filename)."</h1>");
    }
    return $conf;
}

function db_connect() {
    if (is_readable("/etc/amportal.conf")) {
        $amp_conf = parse_amportal_conf("/etc/amportal.conf");
        if(!isset($amp_conf['AMPDBENGINE'])) {
            if(is_file("/etc/freepbx/freepbx.conf")) {
                $amp_conf = parse_amportal_conf("/etc/freepbx/freepbx.conf");
            } else if(is_file("/etc/freepbx.conf")) {
                $amp_conf = parse_amportal_conf("/etc/freepbx.conf");
            }
            $DBHOST = $amp_conf['AMPDBHOST'];
            $DBNAME = $amp_conf['AMPDBNAME'];
            $DBUSER = $amp_conf['AMPDBUSER'];
            $DBPASS = $amp_conf['AMPDBPASS'];
        } else {
            $DBHOST = $amp_conf['AMPDBHOST'];
            $DBNAME = $amp_conf['AMPDBNAME'];
            $DBUSER = $amp_conf['AMPDBUSER'];
            $DBPASS = $amp_conf['AMPDBPASS'];
        }

    } else if (is_readable("/etc/freepbx/freepbx.conf")) {
        $amp_conf = parse_amportal_conf("/etc/freepbx/freepbx.conf");
        $DBHOST = $amp_conf['AMPDBHOST'];
        $DBNAME = $amp_conf['AMPDBNAME'];
        $DBUSER = $amp_conf['AMPDBUSER'];
        $DBPASS = $amp_conf['AMPDBPASS'];
    } else if (is_readable("/etc/freepbx.conf")) {
        $amp_conf = parse_amportal_conf("/etc/freepbx.conf");
        $DBHOST = $amp_conf['AMPDBHOST'];
        $DBNAME = $amp_conf['AMPDBNAME'];
        $DBUSER = $amp_conf['AMPDBUSER'];
        $DBPASS = $amp_conf['AMPDBPASS'];
    } else if (is_readable("/etc/asterisk/snep/snep-features.conf")) {
        $DBHOST = 'localhost';
        $DBNAME = 'snep';
        $DBUSER = 'snep';
        $DBPASS = 'sneppass';
        $CDRDBTABLE = "snep.cdr";
    }
    $db = new dbcon($DBHOST, $DBUSER, $DBPASS, $DBNAME, true, true, true);
    return $db;
}

function export_groups($db) {
    $final_groups = array();
    $res = $db->consulta("SELECT fop2GroupButton.group_name,group_concat(fop2buttons.device) AS groups FROM fop2GroupButton LEFT JOIN fop2buttons ON id_button=fop2buttons.id WHERE group_name NOT LIKE 'All%' GROUP BY group_name");
    while($row=$db->fetch_assoc($res)) {
        $grupos = explode(",",$row['groups']);
        $final_groups[$row['group_name']] = $grupos; 
    }
    return $final_groups;
}

function export_permissions($db) {
    $final_permissions = array();
    $res = $db->consulta("SELECT fop2PermGroup.*,permissions AS fop2permissions FROM fop2PermGroup LEFT JOIN fop2permissions ON fop2PermGroup.name=fop2permissions.name");
    while($row=$db->fetch_assoc($res)) {
        $entry = $row;
        unset($entry['id']);
        $final_permissions[] = $entry;
    }
    return $final_permissions;
}

function export_templates($db) {

    $all_groups = array();
    $res = $db->consulta("SELECT id,name FROM fop2groups");
    while($row=$db->fetch_assoc($res)) {
        $all_groups[$row['id']]=$row['name'];
    }
    
    $final_templates = array();
    $res = $db->consulta("SELECT * FROM fop2templates");
    while($row=$db->fetch_assoc($res)) {
        $entry = $row;
        $group_names=array();
        $groups = preg_split("/,/",$row['groups']);
        foreach($groups as $group) {
            $group_names[]=$all_groups[$group];
        }
        $entry['groups']=$group_names;
        unset($entry['id']);
        $final_templates[] = $entry; 
    }
    return $final_templates;
}

function export_users($db) {
    $final_users = array();
    $res = $db->consulta("SELECT A.*,group_concat(DISTINCT C.name) AS groups,group_concat(DISTINCT E.rawname) AS plugins,IFNULL(group_concat(DISTINCT G.name),'') AS templates FROM fop2users A LEFT JOIN fop2UserGroup B on A.exten=B.exten LEFT JOIN fop2groups C ON B.id_group=C.id LEFT JOIN fop2UserPlugin D on A.exten=D.exten LEFT JOIN fop2plugins E on D.id_plugin=E.rawname LEFT JOIN fop2UserTemplate F ON A.exten=F.exten LEFT JOIN fop2templates G on F.id_template=G.id GROUP BY exten");
    while($row=$db->fetch_assoc($res)) {
        $entry = $row;
        unset($entry['id']);
        $final_users[] = $entry;
    }
    return $final_users;
}

function export_plugins($db) {
    $final_plugins = array();
    $res = $db->consulta("select rawname,global from fop2plugins");
    while($row=$db->fetch_assoc($res)) {
        $entry = $row;
        $final_plugins[] = $entry;
    }
    return $final_plugins;
}

function export_buttons($db) {
    $final_buttons = array();
    $res = $db->consulta("select device,exclude,sortorder,privacy,`group`,email,originatechannel,spyoptions,external,accountcode,tags,originatevariables,cssclass,autoanswerheader from fop2buttons");
    while($row=$db->fetch_assoc($res)) {
        $entry = $row;
        unset($entry['device']);
        $final_buttons[$row['device']] = $entry;
    }
    return $final_buttons;
}

function main($db) {
    $groups      = export_groups($db);
    $permissions = export_permissions($db);
    $templates   = export_templates($db);
    $users       = export_users($db);
    $plugins     = export_plugins($db);
    $buttons     = export_buttons($db);

    $final = array("groups"=>$groups,"permissions"=>$permissions,"templates"=>$templates,"plugins"=>$plugins,"buttons"=>$buttons,"users"=>$users);
    echo json_encode($final);
} 
